//+------------------------------------------------------------------+
//|                                       SpreadAndSwapIndicator.mq4 |
//|                                       Copyright  2013 MATR0SKIN |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013 MATR0SKIN"
#property link      ""
#property indicator_chart_window
//#property indicator_buffers 0

// Vneshnie parametry
extern color TextColor       = Red;
extern int   Corner          = 1;
extern int   VerticalSpace   = 12;
extern int   HorizontalSpace = 3;
extern int   FontSize        = 14;

#define OBJ_LINE1 "MaLine1"
#define OBJ_LINE2 "MaLine2"

int init()
{
   ShowInfo();
}

int start()
{
   ShowInfo();
}

int deinit()
{
   ObjectDelete(OBJ_LINE1);
   ObjectDelete(OBJ_LINE2);

}

void ShowInfo()
{
   static double Spread;
   static double SwapLong;
   static double SwapShort;
   static int digits;
   static string SwapSymbol = "\xBF";
   
   digits    = MarketInfo (Symbol(), MODE_DIGITS);                            //Get symbol's decimal digit's
   
   Spread    = MarketInfo(Symbol(),MODE_SPREAD);                              // Get spread in points

   if ( digits == 5 ) Spread = Spread / 10;                                   //Convert to 4-digit pips
   if ((digits == 3) && (Ask >= 10) && (Ask < 1000)) Spread = Spread / 10;    //Silver,Yen
   if ((digits == 2) && (Ask >= 1000) && (Ask < 10000)) Spread = Spread / 10; //Gold etc

   SwapLong  = MarketInfo(Symbol(),MODE_SWAPLONG);                            //Get swap for long positions
   SwapShort = MarketInfo(Symbol(),MODE_SWAPSHORT);                           //Get swap for short positions

   if ((SwapLong > 0) && (SwapShort < 0)) SwapSymbol = "\xF1";                // Up arrow if we get positive swap on long ones
   if ((SwapLong < 0) && (SwapShort > 0)) SwapSymbol = "\xF2";                // Down arrow if we get positive swap on short ones
   if ((SwapLong < 0) && (SwapShort < 0)) SwapSymbol = "\x4E";                // Skull if both swaps negative
   if ((SwapLong > 0) && (SwapShort > 0)) SwapSymbol = "\x41";                // Victory if both swaps positive (this ever happened???)
   
   DrawOnChart  (Spread, SwapLong, SwapShort, SwapSymbol);                    // Output both lines
   
}
void DrawOnChart(double Spread, double SwapLong, double SwapShort, string SwapSymbol)

{
   string InfoString = DoubleToStr(Spread,    1);
                       //+" "+Ask+" "+Digits;
                       //Swap;
                       //DoubleToStr(SwapLong,  2)+
                       //" "+
                       //DoubleToStr(SwapShort, 2);
   
   if(ObjectFind(OBJ_LINE1) < 0)
   {
      ObjectCreate (OBJ_LINE1, OBJ_LABEL, 0, 0, 0);
      ObjectSet    (OBJ_LINE1, OBJPROP_CORNER, Corner);
      ObjectSet    (OBJ_LINE1, OBJPROP_YDISTANCE, VerticalSpace);
      ObjectSet    (OBJ_LINE1, OBJPROP_XDISTANCE, HorizontalSpace);
      ObjectSetText(OBJ_LINE1, InfoString, FontSize, "Courier", TextColor);
   }
   ObjectSetText(OBJ_LINE1, InfoString);

   if(ObjectFind(OBJ_LINE2) < 0) 
   {
      ObjectCreate (OBJ_LINE2, OBJ_LABEL, 0, 0, 0);
      ObjectSet    (OBJ_LINE2, OBJPROP_CORNER, Corner);
      ObjectSet    (OBJ_LINE2, OBJPROP_YDISTANCE, VerticalSpace+FontSize+3);
      ObjectSet    (OBJ_LINE2, OBJPROP_XDISTANCE, HorizontalSpace);
      ObjectSetText(OBJ_LINE2, SwapSymbol, FontSize, "Wingdings", TextColor);                      //Draw Swap Symbol
   }
   ObjectSetText(OBJ_LINE2, SwapSymbol);
   WindowRedraw();
}